commit 22a6d1d98481bdec1b4d9752b84178a8e7b175c3
Author: freddy77 <freddy77>
Date:   Tue Mar 17 09:05:47 2009 +0000

    relax some tests

diff --git a/ChangeLog b/ChangeLog
index ddd8c48..e35535a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Tue Mar 17 10:05:23 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/genparams.c src/odbc/unittests/moreandcount.c:
+	* src/odbc/unittests/typeinfo.c:
+	- relax some tests
+
 Mon Mar 16 21:46:05 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* win32/tds_sysdep_public.h:
 	- fix redefinition (due to change on Fri Feb 27 11:46:15 CET 2009)
@@ -1409,4 +1414,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2751 2009/03/16 20:46:20 freddy77 Exp $
+$Id: ChangeLog,v 1.2752 2009/03/17 09:05:47 freddy77 Exp $
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 27e9fda..acb7ecb 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -18,7 +18,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.41 2009/03/09 20:53:53 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.42 2009/03/17 09:05:47 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -354,8 +354,8 @@ AllTests(void)
 	TestInput(SQL_C_CHAR, "VARCHAR(100)", SQL_VARBINARY, "VARBINARY(20)", "4145544F -> AETO");
 	TestInput(SQL_C_CHAR, "TEXT", SQL_VARBINARY, "VARBINARY(20)", "4145544F -> AETO");
 	TestInput(SQL_C_CHAR, "VARCHAR(100)", SQL_LONGVARBINARY, "IMAGE", "4145544F -> AETO");
-	TestInput(SQL_C_BINARY, "VARBINARY(100)", SQL_VARCHAR, "VARCHAR(20)", "0x4145544F -> 4145544F");
-	TestInput(SQL_C_BINARY, "IMAGE", SQL_VARCHAR, "VARCHAR(20)", "0x4145544F -> 4145544F");
+	TestInput(SQL_C_BINARY, "VARBINARY(100)", SQL_VARCHAR, "VARCHAR(20)", "0x4145544F -> AETO");
+	TestInput(SQL_C_BINARY, "IMAGE", SQL_VARCHAR, "VARCHAR(20)", "0x4145544F -> AETO");
 
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "0");
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "1");
@@ -420,8 +420,8 @@ AllTests(void)
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_VARBINARY, "VARBINARY(20)", "4145544F -> AETO");
 		TestInput(SQL_C_CHAR, "NTEXT", SQL_VARBINARY, "VARBINARY(20)", "4145544F -> AETO");
 
-		TestInput(SQL_C_BINARY, "VARBINARY(100)", SQL_WVARCHAR, "NVARCHAR(20)", "0x4145544F -> 4145544F");
-		TestInput(SQL_C_BINARY, "IMAGE", SQL_WVARCHAR, "NVARCHAR(20)", "0x4145544F -> 4145544F");
+		TestInput(SQL_C_BINARY, "VARBINARY(100)", SQL_WVARCHAR, "NVARCHAR(20)", "0x4100450054004F00 -> AETO");
+		TestInput(SQL_C_BINARY, "IMAGE", SQL_WVARCHAR, "NVARCHAR(20)", "0x4100450054004F00 -> AETO");
 	}
 }
 
diff --git a/src/odbc/unittests/moreandcount.c b/src/odbc/unittests/moreandcount.c
index db65f84..3828288 100644
--- a/src/odbc/unittests/moreandcount.c
+++ b/src/odbc/unittests/moreandcount.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults and SQLRowCount on batch */
 
-static char software_version[] = "$Id: moreandcount.c,v 1.17 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: moreandcount.c,v 1.18 2009/03/17 09:05:47 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -65,7 +65,8 @@ DoTest(int prepare)
 	CHECK_COLS(1);
 	if (prepare) {
 		/* collapse 2 recordset... after a lot of testing this is the behavior! */
-		CHECK_ROWS(2);
+		if (driver_is_freetds())
+			CHECK_ROWS(2);
 	} else {
 		CHECK_ROWS(1);
 		CHKMoreResults("S");
diff --git a/src/odbc/unittests/typeinfo.c b/src/odbc/unittests/typeinfo.c
index b716b65..7a28c61 100644
--- a/src/odbc/unittests/typeinfo.c
+++ b/src/odbc/unittests/typeinfo.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: typeinfo.c,v 1.12 2008/12/03 12:55:52 freddy77 Exp $";
+static char software_version[] = "$Id: typeinfo.c,v 1.13 2009/03/17 09:05:47 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -49,6 +49,7 @@ CheckType(SQLSMALLINT type, SQLSMALLINT expected, const char *string_type, int l
 	SQLLEN ind;
 	SQLRETURN RetCode;
 
+	printf("CheckType %d\n", line);
 	CHKBindCol(2, SQL_C_SSHORT, &out_type, 0, &ind, "SI");
 	CHKGetTypeInfo(type, "SI");
 	RetCode = CHKFetch("SNo");
@@ -87,17 +88,22 @@ DoTest(int version3)
 	SQLINTEGER col_size, min_scale;
 	SQLLEN ind1, ind2, ind3, ind4, ind5, ind6;
 	int date_time_supported = 0;
+	int name_version3;
 
 	use_odbc_version3 = version3;
+	name_version3 = version3;
 	Connect();
 
 	printf("Using ODBC version %d\n", version3 ? 3 : 2);
 
 	/* test column name */
+	/* MS ODBC use always ODBC 3 names even in ODBC 2 mode */
+	if (!driver_is_freetds())
+		name_version3 = 1;
 	CHKGetTypeInfo(SQL_ALL_TYPES, "SI");
 	TestName(1, "TYPE_NAME");
 	TestName(2, "DATA_TYPE");
-	TestName(3, version3 ? "COLUMN_SIZE" : "PRECISION");
+	TestName(3, name_version3 ? "COLUMN_SIZE" : "PRECISION");
 	TestName(4, "LITERAL_PREFIX");
 	TestName(5, "LITERAL_SUFFIX");
 	TestName(6, "CREATE_PARAMS");
@@ -105,8 +111,8 @@ DoTest(int version3)
 	TestName(8, "CASE_SENSITIVE");
 	TestName(9, "SEARCHABLE");
 	TestName(10, "UNSIGNED_ATTRIBUTE");
-	TestName(11, version3 ? "FIXED_PREC_SCALE" : "MONEY");
-	TestName(12, version3 ? "AUTO_UNIQUE_VALUE" : "AUTO_INCREMENT");
+	TestName(11, name_version3 ? "FIXED_PREC_SCALE" : "MONEY");
+	TestName(12, name_version3 ? "AUTO_UNIQUE_VALUE" : "AUTO_INCREMENT");
 	TestName(13, "LOCAL_TYPE_NAME");
 	TestName(14, "MINIMUM_SCALE");
 	TestName(15, "MAXIMUM_SCALE");
@@ -132,10 +138,20 @@ DoTest(int version3)
 
 	CHECK_TYPE(SQL_DATE, date_time_supported && !version3 ? SQL_DATE : SQL_UNKNOWN_TYPE);
 	CHECK_TYPE(SQL_TIME, date_time_supported && !version3 ? SQL_TIME : SQL_UNKNOWN_TYPE);
-	CHECK_TYPE(SQL_TYPE_DATE, date_time_supported && version3 ? SQL_TYPE_DATE : SQL_UNKNOWN_TYPE);
-	CHECK_TYPE(SQL_TYPE_TIME, date_time_supported && version3 ? SQL_TYPE_TIME : SQL_UNKNOWN_TYPE);
-	CHECK_TYPE(SQL_TIMESTAMP, version3 ? SQL_UNKNOWN_TYPE : SQL_TIMESTAMP);
-	CHECK_TYPE(SQL_TYPE_TIMESTAMP, version3 ? SQL_TYPE_TIMESTAMP : SQL_UNKNOWN_TYPE);
+	/* MS ODBC returns S1004 (HY004), TODO support it */
+	if (driver_is_freetds() || version3) {
+		CHECK_TYPE(SQL_TYPE_DATE, date_time_supported && version3 ? SQL_TYPE_DATE : SQL_UNKNOWN_TYPE);
+		CHECK_TYPE(SQL_TYPE_TIME, date_time_supported && version3 ? SQL_TYPE_TIME : SQL_UNKNOWN_TYPE);
+	}
+	/* TODO MS ODBC handle SQL_TIMESTAMP even for ODBC 3 */
+	if (driver_is_freetds())
+		CHECK_TYPE(SQL_TIMESTAMP, version3 ? SQL_UNKNOWN_TYPE : SQL_TIMESTAMP);
+	else
+		CHECK_TYPE(SQL_TIMESTAMP, version3 ? SQL_TYPE_TIMESTAMP : SQL_TIMESTAMP);
+	/* MS ODBC returns S1004 (HY004), TODO support it */
+	if (driver_is_freetds() || version3) {
+		CHECK_TYPE(SQL_TYPE_TIMESTAMP, version3 ? SQL_TYPE_TIMESTAMP : SQL_UNKNOWN_TYPE);
+	}
 
 	/* TODO implement this part of test */
 	/* varchar/nvarchar before sysname */

